procedure EnableAbsoluteRotations(Val: Boolean);
begin
	if Val = True then
		PrometheusVideo.RotationMode := Mode_Absolute;
end;

procedure EnableIncrementalRotations(Val: Boolean);
begin
	if Val = True then
		PrometheusVideo.RotationMode := Mode_Incremental;
end;

function GetRotationMode(): LongWord;
begin
	GetRotationMode := PrometheusVideo.RotationMode;
end;

procedure SetFullScreen(Val: Boolean);
begin
	PrometheusVideo.FullScreen := Val;
	if PrometheusVideo.UpdateMode = Update_Auto then
		UpdateWindow();
end;

function GetPrometheusAA_Rotating(): Int64;
begin
	GetPrometheusAA_Rotating := PrometheusVideo.AA_Roto;
	//writeln('Returned AA parameters OK');
end;

procedure SetPrometheusAA_Rotating(Val: Int64);
begin
	PrometheusVideo.AA_Roto := Val;
end;

function GetPrometheusAA_Scaling(): Int64;
begin
	GetPrometheusAA_Scaling := PrometheusVideo.AA_Scale;
	//writeln('Returned AA parameters OK');
end;

procedure SetPrometheusAA_Scaling(Val: Int64);
begin
	PrometheusVideo.AA_Scale := Val;
end;

procedure LoadToVRam(Dat: pSdl_Surface);
begin
	PrometheusVideo.VRam := Dat;
end;

function GetVRam(): pSdl_Surface;
begin
	GetVRam := PrometheusVideo.VRam;
end;

procedure ClearVRam();
begin
	sdl_freesurface(PrometheusVideo.VRam);
end;

function DWordToVertex(DW: DWord): Vertex;
begin
	if DW = UpperLeft then
		DWordToVertex := vertUpperLeft;
	if DW = UpperRight then
		DWordToVertex := vertUpperRight;
	if DW = LowerLeft then
		DWordToVertex := vertLowerLeft;
	if DW = LowerRight then
		DWordToVertex := vertLowerRight;
	if DW = Centre then
		DWordToVertex := vertCentre;
	if DW = RectangleFill then
		DWordToVertex := vertRectangleFill;
	if DW = SquareFill then
		DWordToVertex := vertSquareFill;
end;

procedure SetColourDepth(Val: Int64);
begin
	PrometheusVideo.ColourDepth := Val;
end;

function GetPrometheusUpdateMode(): Boolean;
begin
	GetPrometheusUpdateMode := PrometheusVideo.UpdateMode;
end;

procedure SetPrometheusUpdateMode(Val: Boolean);
begin
	PrometheusVideo.UpdateMode := Val;
end;

procedure SetWindowSize(X,Y: Int64);
begin
	PrometheusVideo.WindowWidth := X;
	PrometheusVideo.WindowHeight := Y;
	if PrometheusVideo.UpdateMode = Update_Auto then
		UpdateWindow();
end;

procedure UpdateCanvas();
begin
    Sdl_Gl_SwapBuffers();
end;

procedure UpdateWindow();
begin
    Sdl_FreeSurface(PrometheusVideo.Screen);
    if PrometheusVideo.FullScreen = False then
		PrometheusVideo.Screen := SDL_SetVideoMode(PrometheusVideo.WindowWidth, PrometheusVideo.WindowHeight, PrometheusVideo.ColourDepth, Sdl_OpenGl)
	else
		PrometheusVideo.Screen := SDL_SetVideoMode(PrometheusVideo.WindowWidth, PrometheusVideo.WindowHeight, PrometheusVideo.ColourDepth, Sdl_OpenGl or Sdl_FullScreen);
    
    glEnable( GL_TEXTURE_2D );
 
    glClearColor( 0.0, 0.0, 0.0, 0.0 );
     
    glViewport( 0, 0, PrometheusVideo.WindowWidth, PrometheusVideo.WindowHeight );
     
    glClear( GL_COLOR_BUFFER_BIT );
     
    glMatrixMode( GL_PROJECTION );
    glLoadIdentity();
     
    //glOrtho(0.0, PrometheusVideo.WindowWidth, PrometheusVideo.WindowHeight, 0.0, -1.0, 1.0);
    glOrtho(0, PrometheusVideo.WindowWidth, PrometheusVideo.WindowHeight, 0, -16, 16);
    
    glMatrixMode( GL_MODELVIEW );
    glLoadIdentity();
    SDL_GL_SwapBuffers();
end;

procedure PrometheusVid_Start();
begin
    SDL_Init(SDL_INIT_EVERYTHING);
    TTF_Init();
    
    SDL_GL_SetAttribute( SDL_GL_DOUBLEBUFFER, 1 ); 
     
    PrometheusVideo.Screen := SDL_SetVideoMode(PrometheusVideo.WindowWidth, PrometheusVideo.WindowHeight, PrometheusVideo.ColourDepth, Sdl_OpenGl);
    
    glEnable( GL_TEXTURE_2D );
 
    glClearColor( 0.0, 0.0, 0.0, 0.0 );
     
    glViewport( 0, 0, PrometheusVideo.WindowWidth, PrometheusVideo.WindowHeight );
     
    glClear( GL_COLOR_BUFFER_BIT );
     
    glMatrixMode( GL_PROJECTION );
    glLoadIdentity();
    
    //aim: glOrtho(0, 1280, 720, 0, -16, 16); 
    glOrtho(0.0, PrometheusVideo.WindowWidth, PrometheusVideo.WindowHeight, 0.0, -16, 16);
	    
    glMatrixMode( GL_MODELVIEW );
    glLoadIdentity();
    
    glEnable (GL_BLEND); 
    glBlendFunc (GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
    
    PrometheusVideo.RotationMode := Mode_Absolute;
    PrometheusVideo.Initialized := True;
end;

procedure CreateWindow(Width, Height, BPP: Int64);
begin
	SetWindowSize(Width, Height);
	SetColourDepth(BPP);
	UpdateWindow();
	UpdateCanvas();
end;

procedure ClearCanvas();
begin
	//sdl_fillrect(Sdl_GetVideoSurface(), nil, 0);
	glClear(GL_COLOR_BUFFER_BIT);
	//UpdateWindow();
end;
